/**
 * @name string-remove-duplicate-heads-tails
 * @fileoverview Detect and (recursively) remove head and tail wrappings around the input string
 * @version 7.0.19
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-remove-duplicate-heads-tails/}
 */

"use strict";var stringRemoveDuplicateHeadsTails=(()=>{var ie=Object.create;var F=Object.defineProperty;var se=Object.getOwnPropertyDescriptor;var ae=Object.getOwnPropertyNames,L=Object.getOwnPropertySymbols,oe=Object.getPrototypeOf,k=Object.prototype.hasOwnProperty,le=Object.prototype.propertyIsEnumerable;var J=(e,n,o)=>n in e?F(e,n,{enumerable:!0,configurable:!0,writable:!0,value:o}):e[n]=o,$=(e,n)=>{for(var o in n||(n={}))k.call(n,o)&&J(e,o,n[o]);if(L)for(var o of L(n))le.call(n,o)&&J(e,o,n[o]);return e};var ue=(e,n)=>()=>(n||e((n={exports:{}}).exports,n),n.exports),fe=(e,n)=>{for(var o in n)F(e,o,{get:n[o],enumerable:!0})},q=(e,n,o,i)=>{if(n&&typeof n=="object"||typeof n=="function")for(let l of ae(n))!k.call(e,l)&&l!==o&&F(e,l,{get:()=>n[l],enumerable:!(i=se(n,l))||i.enumerable});return e};var ge=(e,n,o)=>(o=e!=null?ie(oe(e)):{},q(n||!e||!e.__esModule?F(o,"default",{value:e,enumerable:!0}):o,e)),ce=e=>q(F({},"__esModule",{value:!0}),e);var j=(e,n,o)=>(J(e,typeof n!="symbol"?n+"":n,o),o);var U=ue((ve,P)=>{"use strict";P.exports=he;function I(e){return e instanceof Buffer?Buffer.from(e):new e.constructor(e.buffer.slice(),e.byteOffset,e.length)}function he(e){if(e=e||{},e.circles)return me(e);return e.proto?i:o;function n(l,r){for(var a=Object.keys(l),s=new Array(a.length),u=0;u<a.length;u++){var t=a[u],f=l[t];typeof f!="object"||f===null?s[t]=f:f instanceof Date?s[t]=new Date(f):ArrayBuffer.isView(f)?s[t]=I(f):s[t]=r(f)}return s}function o(l){if(typeof l!="object"||l===null)return l;if(l instanceof Date)return new Date(l);if(Array.isArray(l))return n(l,o);if(l instanceof Map)return new Map(n(Array.from(l),o));if(l instanceof Set)return new Set(n(Array.from(l),o));var r={};for(var a in l)if(Object.hasOwnProperty.call(l,a)!==!1){var s=l[a];typeof s!="object"||s===null?r[a]=s:s instanceof Date?r[a]=new Date(s):s instanceof Map?r[a]=new Map(n(Array.from(s),o)):s instanceof Set?r[a]=new Set(n(Array.from(s),o)):ArrayBuffer.isView(s)?r[a]=I(s):r[a]=o(s)}return r}function i(l){if(typeof l!="object"||l===null)return l;if(l instanceof Date)return new Date(l);if(Array.isArray(l))return n(l,i);if(l instanceof Map)return new Map(n(Array.from(l),i));if(l instanceof Set)return new Set(n(Array.from(l),i));var r={};for(var a in l){var s=l[a];typeof s!="object"||s===null?r[a]=s:s instanceof Date?r[a]=new Date(s):s instanceof Map?r[a]=new Map(n(Array.from(s),i)):s instanceof Set?r[a]=new Set(n(Array.from(s),i)):ArrayBuffer.isView(s)?r[a]=I(s):r[a]=i(s)}return r}}function me(e){var n=[],o=[];return e.proto?r:l;function i(a,s){for(var u=Object.keys(a),t=new Array(u.length),f=0;f<u.length;f++){var m=u[f],y=a[m];if(typeof y!="object"||y===null)t[m]=y;else if(y instanceof Date)t[m]=new Date(y);else if(ArrayBuffer.isView(y))t[m]=I(y);else{var c=n.indexOf(y);c!==-1?t[m]=o[c]:t[m]=s(y)}}return t}function l(a){if(typeof a!="object"||a===null)return a;if(a instanceof Date)return new Date(a);if(Array.isArray(a))return i(a,l);if(a instanceof Map)return new Map(i(Array.from(a),l));if(a instanceof Set)return new Set(i(Array.from(a),l));var s={};n.push(a),o.push(s);for(var u in a)if(Object.hasOwnProperty.call(a,u)!==!1){var t=a[u];if(typeof t!="object"||t===null)s[u]=t;else if(t instanceof Date)s[u]=new Date(t);else if(t instanceof Map)s[u]=new Map(i(Array.from(t),l));else if(t instanceof Set)s[u]=new Set(i(Array.from(t),l));else if(ArrayBuffer.isView(t))s[u]=I(t);else{var f=n.indexOf(t);f!==-1?s[u]=o[f]:s[u]=l(t)}}return n.pop(),o.pop(),s}function r(a){if(typeof a!="object"||a===null)return a;if(a instanceof Date)return new Date(a);if(Array.isArray(a))return i(a,r);if(a instanceof Map)return new Map(i(Array.from(a),r));if(a instanceof Set)return new Set(i(Array.from(a),r));var s={};n.push(a),o.push(s);for(var u in a){var t=a[u];if(typeof t!="object"||t===null)s[u]=t;else if(t instanceof Date)s[u]=new Date(t);else if(t instanceof Map)s[u]=new Map(i(Array.from(t),r));else if(t instanceof Set)s[u]=new Set(i(Array.from(t),r));else if(ArrayBuffer.isView(t))s[u]=I(t);else{var f=n.indexOf(t);f!==-1?s[u]=o[f]:s[u]=r(t)}}return n.pop(),o.pop(),s}}});var Ee={};fe(Ee,{defaults:()=>ne,remDup:()=>De,version:()=>Ae});var Q=ge(U(),1);var Se=(0,Q.default)();function R(e){if(e==null||typeof e!="object")return!1;let n=Object.getPrototypeOf(e);return n!==null&&n!==Object.prototype&&Object.getPrototypeOf(n)!==null?!1:!(Symbol.iterator in e)&&!(Symbol.toStringTag in e)}function D(e){return typeof e=="string"}function E(e){return Number.isSafeInteger(e)&&e>=0}function M(e){return e!=null}function G(e,n){return R(e)&&D(n)&&n in e}function S(e){return typeof e!="string"?e:e.length?[e]:[]}var z={cb:void 0,i:!1,trimBeforeMatching:!1,trimCharsBeforeMatching:[],maxMismatches:0,firstMustMatch:!1,lastMustMatch:!1,hungry:!1},pe=e=>e+1;function ye(e,n,o,i,l=!1,r=pe){var w;let a=typeof o=="function"?o():o;if(+n<0&&l&&a==="EOL")return a;let s=$($({},z),i);if(n>=e.length&&!l)return!1;let u=l?1:o.length,t=0,f=!1,m=!1,y=!1,c=s.maxMismatches,h=n,g=!1,T=!1,p=!1;function O(){return t===1&&c<s.maxMismatches-1}for(;e[h];){let d=r(h);if(s.trimBeforeMatching&&e[h].trim()===""){if(!e[d]&&l&&o==="EOL")return!0;h=r(h);continue}if(s&&!s.i&&((w=s==null?void 0:s.trimCharsBeforeMatching)!=null&&w.includes(e[h]))||s!=null&&s.i&&s.trimCharsBeforeMatching&&s.trimCharsBeforeMatching.map(b=>b.toLowerCase()).includes(e[h].toLowerCase())){if(l&&o==="EOL"&&!e[d])return!0;h=r(h);continue}let A=d>h?o[o.length-u]:o[u-1];if(!s.i&&e[h]===A||s.i&&e[h].toLowerCase()===A.toLowerCase()){if(g||(g=!0),y||(y=!0),u===o.length){if(T=!0,c!==s.maxMismatches)return!1}else u===1&&(p=!0);if(u-=1,t++,O())return!1;if(!u)return t!==o.length||c===s.maxMismatches||!f?h:!1}else if(!f&&!t&&(f=!0),s.maxMismatches&&c&&h){c-=1;for(let b=0;b<=c;b++){let v=d>h?o[o.length-u+1+b]:o[u-2-b],_=e[r(h)];if(v&&(!s.i&&e[h]===v||s.i&&e[h].toLowerCase()===v.toLowerCase())&&(!s.firstMustMatch||u!==o.length)){if(t++,O())return!1;u-=2,g=!0;break}else if(_&&v&&(!s.i&&_===v||s.i&&_.toLowerCase()===v.toLowerCase())&&(!s.firstMustMatch||u!==o.length)){if(!t&&!s.hungry)return!1;u-=1,g=!0;break}else if(v===void 0&&c>=0&&g&&(!s.firstMustMatch||T)&&(!s.lastMustMatch||p))return h}g||(m=h)}else return h===0&&u===1&&!s.lastMustMatch&&y?0:!1;if(m!==!1&&m!==h&&(m=!1),u<1)return h;h=r(h)}if(u>0)return l&&a==="EOL"?!0:s&&s.maxMismatches>=u&&y?m||0:!1}function K(e,n,o,i,l){var f,m,y;if(R(l)&&G(l,"trimBeforeMatching")&&l&&typeof l.trimBeforeMatching!="boolean")throw new Error(`string-match-left-right/${e}(): [THROW_ID_09] opts.trimBeforeMatching should be boolean!${Array.isArray(l.trimBeforeMatching)?" Did you mean to use opts.trimCharsBeforeMatching?":""}`);let r=$($({},z),l);if(typeof r.trimCharsBeforeMatching=="string"&&(r.trimCharsBeforeMatching=S(r.trimCharsBeforeMatching)),r.trimCharsBeforeMatching=r.trimCharsBeforeMatching.map(c=>D(c)?c:String(c)),!D(n)||!n.length)return!1;if(!Number.isInteger(o)||o<0)throw new Error(`string-match-left-right/${e}(): [THROW_ID_03] the second argument should be a natural number. Currently it's of a type: ${typeof o}, equal to:
${JSON.stringify(o,null,4)}`);let a,s;if(D(i))a=[i];else if(Array.isArray(i))a=i;else if(!i)a=i;else if(typeof i=="function")a=[],a.push(i);else throw new Error(`string-match-left-right/${e}(): [THROW_ID_05] the third argument, whatToMatch, is neither string nor array of strings! It's ${typeof i}, equal to:
${JSON.stringify(i,null,4)}`);if(l&&!R(l))throw new Error(`string-match-left-right/${e}(): [THROW_ID_06] the fourth argument, options object, should be a plain object. Currently it's of a type "${typeof l}", and equal to:
${JSON.stringify(l,null,4)}`);let u=0,t="";if((f=r==null?void 0:r.trimCharsBeforeMatching)!=null&&f.some((c,h)=>c.length>1?(u=h,t=c,!0):!1))throw new Error(`string-match-left-right/${e}(): [THROW_ID_07] the fourth argument, options object contains trimCharsBeforeMatching. It was meant to list the single characters but one of the entries at index ${u} is longer than 1 character, ${t.length} (equals to ${t}). Please split it into separate characters and put into array as separate elements.`);if(!a||!Array.isArray(a)||Array.isArray(a)&&!a.length||Array.isArray(a)&&a.length===1&&D(a[0])&&!a[0].trim()){if(typeof r.cb=="function"){let h,g=o;if((e==="matchLeftIncl"||e==="matchRight")&&(g+=1),e[5]==="L")for(let w=g;w--;){let d=n[w];if((!r.trimBeforeMatching||r.trimBeforeMatching&&(d!=null&&d.trim()))&&(!((m=r.trimCharsBeforeMatching)!=null&&m.length)||d!==void 0&&!r.trimCharsBeforeMatching.includes(d))){h=w;break}}else if(e.startsWith("matchRight"))for(let w=g;w<n.length;w++){let d=n[w];if((!r.trimBeforeMatching||r.trimBeforeMatching&&d.trim())&&(!((y=r.trimCharsBeforeMatching)!=null&&y.length)||!r.trimCharsBeforeMatching.includes(d))){h=w;break}}if(h===void 0)return!1;let T=n[h],p=h+1,O="";return p&&p>0&&(O=n.slice(0,p)),e[5]==="L"||h&&h>0&&(O=n.slice(h)),r.cb(T,O,h)}let c="";throw l||(c=" More so, the whole options object, the fourth input argument, is missing!"),new Error(`string-match-left-right/${e}(): [THROW_ID_08] the third argument, "whatToMatch", was given as an empty string. This means, you intend to match purely by a callback. The callback was not set though, the opts key "cb" is not set!${c}`)}for(let c=0,h=a.length;c<h;c++){s=typeof a[c]=="function";let g=a[c],T,p,O="",w=o;e==="matchRight"?w+=1:e==="matchLeft"&&(w-=1);let d=ye(n,w,g,r,s,A=>e[5]==="L"?A-1:A+1);if(d&&s&&typeof g=="function"&&g()==="EOL")return g()&&(!r.cb||r.cb(T,O,p))?g():!1;if(Number.isInteger(d)&&(p=e.startsWith("matchLeft")?d-1:d+1,e[5]==="L"?O=n.slice(0,d):O=n.slice(p)),p<0&&(p=void 0),n[p]&&(T=n[p]),Number.isInteger(d)&&(!r.cb||r.cb(T,O,p)))return g}return!1}function V(e,n,o,i){return K("matchLeftIncl",e,n,o,i)}function N(e,n,o,i){return K("matchRightIncl",e,n,o,i)}function B(e,n=1){let o="\xA0";function i(r){return Array.from(r).reverse().join("")}function l(r,a,s){let u=s?`
`:"\r",t=s?"\r":`
`;if(!r)return r;let f=0,m=0,y="";for(let c=0,h=r.length;c<h;c++)(r[c]===u||r[c]===t&&r[c-1]!==u)&&m++,`\r
`.includes(r[c])||r[c]===o?(f=0,r[c]===o?y+=r[c]:r[c]===u?m<=a&&(y+=r[c],r[c+1]===t&&(y+=r[c+1],c++)):r[c]===t&&(r==null?void 0:r[c-1])!==u&&m<=a&&(y+=r[c])):(f++,!r[c+1]&&!m&&(y+=" "));return y}if(typeof e=="string"&&e.length){let r=1;typeof+n=="number"&&Number.isInteger(+n)&&+n>=0&&(r=+n);let a="",s="";if(!e.trim())a=e;else if(!e[0].trim()){for(let u=0,t=e.length;u<t;u++)if(e[u].trim()){a=e.slice(0,u);break}}if(e.trim()&&(e.slice(-1).trim()===""||e.slice(-1)===o)){for(let u=e.length;u--;)if(e[u].trim()){s=e.slice(u+1);break}}return`${l(a,r,!1)}${e.trim()}${i(l(i(s),r,!0))}`}return e}var de={strictlyTwoElementsInRangeArrays:!1,progressFn:null};function C(e,n){if(!Array.isArray(e)||!e.length)return e;let o=$($({},de),n),i,l;if(o.strictlyTwoElementsInRangeArrays&&!e.every((s,u)=>!Array.isArray(s)||s.length!==2?(i=u,l=s.length,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${i}th range (${JSON.stringify(e[i],null,4)}) has not two but ${l} elements!`);if(!e.every((s,u)=>!Array.isArray(s)||!Number.isInteger(s[0])||s[0]<0||!Number.isInteger(s[1])||s[1]<0?(i=u,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${i}th range (${JSON.stringify(e[i],null,4)}) does not consist of only natural numbers!`);let r=e.length**2,a=0;return Array.from(e).sort((s,u)=>(o.progressFn&&(a+=1,o.progressFn(Math.floor(a*100/r))),s[0]===u[0]?s[1]<u[1]?-1:s[1]>u[1]?1:0:s[0]<u[0]?-1:1))}var Z={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function $e(e,n){function o(t){return!!t&&typeof t=="object"&&!Array.isArray(t)}if(!Array.isArray(e)||!e.length)return null;let i;if(n)if(o(n)){if(i=$($({},Z),n),i.progressFn&&o(i.progressFn)&&!Object.keys(i.progressFn).length)i.progressFn=null;else if(i.progressFn&&typeof i.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] resolvedOpts.progressFn must be a function! It was given of a type: "${typeof i.progressFn}", equal to ${JSON.stringify(i.progressFn,null,4)}`);if(![1,2,"1","2"].includes(i.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] resolvedOpts.mergeType was customised to a wrong thing! It was given of a type: "${typeof i.mergeType}", equal to ${JSON.stringify(i.mergeType,null,4)}`);if(typeof i.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] resolvedOpts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof i.joinRangesThatTouchEdges}", equal to ${JSON.stringify(i.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(n,null,4)} (type ${typeof n})`);else i=$({},Z);let l=e.filter(t=>Array.isArray(t)).map(t=>[...t]).filter(t=>t[2]!==void 0||t[0]!==t[1]),r,a,s;i.progressFn?r=C(l,{progressFn:t=>{s=Math.floor(t/5),s!==a&&(a=s,i.progressFn(s))}}):r=C(l);let u=r.length-1;for(let t=u;t>0;t--)i.progressFn&&(s=Math.floor((1-t/u)*78)+21,s!==a&&s>a&&(a=s,i.progressFn(s))),(r[t][0]<=r[t-1][0]||!i.joinRangesThatTouchEdges&&r[t][0]<r[t-1][1]||i.joinRangesThatTouchEdges&&r[t][0]<=r[t-1][1])&&(r[t-1][0]=Math.min(r[t][0],r[t-1][0]),r[t-1][1]=Math.max(r[t][1],r[t-1][1]),r[t][2]!==void 0&&(r[t-1][0]>=r[t][0]||r[t-1][1]<=r[t][1])&&r[t-1][2]!==null&&(r[t][2]===null&&r[t-1][2]!==null?r[t-1][2]=null:r[t-1][2]!=null?+i.mergeType==2&&r[t-1][0]===r[t][0]?r[t-1][2]=r[t][2]:r[t-1][2]+=r[t][2]:r[t-1][2]=r[t][2]),r.splice(t,1),t=r.length);return r.length?r:null}var be={limitToBeAddedWhitespace:!1,limitLinebreaksCount:1,mergeType:1},H=class{constructor(e){j(this,"ranges");j(this,"opts");let n=$($({},be),e);if(n.mergeType&&n.mergeType!==1&&n.mergeType!==2)if(D(n.mergeType)&&n.mergeType.trim()==="1")n.mergeType=1;else if(D(n.mergeType)&&n.mergeType.trim()==="2")n.mergeType=2;else throw new Error(`ranges-push: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof n.mergeType}", equal to ${JSON.stringify(n.mergeType,null,4)}`);this.opts=n,this.ranges=[]}add(e,n,o){var r;if(e==null&&n==null)return;if(M(e)&&!M(n)){if(Array.isArray(e)){if(e.length){if(e.some(a=>Array.isArray(a))){e.forEach(a=>{Array.isArray(a)&&this.add(...a)});return}e.length&&E(+e[0])&&E(+e[1])&&this.add(...e)}return}throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_12] the first input argument, "from" is set (${JSON.stringify(e,null,0)}) but second-one, "to" is not (${JSON.stringify(n,null,0)})`)}else if(!M(e)&&M(n))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_13] the second input argument, "to" is set (${JSON.stringify(n,null,0)}) but first-one, "from" is not (${JSON.stringify(e,null,0)})`);let i=+e,l=+n;if(E(o)&&(o=String(o)),E(i)&&E(l)){if(M(o)&&!D(o)&&!E(o))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_08] The third argument, the value to add, was given not as string but ${typeof o}, equal to:
${JSON.stringify(o,null,4)}`);if(M(this.ranges)&&Array.isArray(this.last())&&i===this.last()[1]){if(this.last()[1]=l,this.last()[2],this.last()[2]!==null&&M(o)){let a=this.last()[2]&&this.last()[2].length&&(!((r=this.opts)!=null&&r.mergeType)||this.opts.mergeType===1)?`${this.last()[2]}${o}`:o;this.opts.limitToBeAddedWhitespace&&(a=B(a,this.opts.limitLinebreaksCount)),D(a)&&!a.length||(this.last()[2]=a)}}else{this.ranges||(this.ranges=[]);let a=o!==void 0&&!(D(o)&&!o.length)?[i,l,o&&this.opts.limitToBeAddedWhitespace?B(o,this.opts.limitLinebreaksCount):o]:[i,l];this.ranges.push(a)}}else throw E(i)&&i>=0?new TypeError(`ranges-push/Ranges/add(): [THROW_ID_10] "to" value, the second input argument, must be a natural number or zero! Currently it's of a type "${typeof l}" equal to: ${JSON.stringify(l,null,4)}`):new TypeError(`ranges-push/Ranges/add(): [THROW_ID_09] "from" value, the first input argument, must be a natural number or zero! Currently it's of a type "${typeof i}" equal to: ${JSON.stringify(i,null,4)}`)}push(e,n,o){this.add(e,n,o)}current(){return Array.isArray(this.ranges)&&this.ranges.length?(this.ranges=$e(this.ranges,{mergeType:this.opts.mergeType}),this.ranges&&this.opts.limitToBeAddedWhitespace?this.ranges.map(e=>M(e[2])?[e[0],e[1],B(e[2],this.opts.limitLinebreaksCount)]:e):this.ranges):null}wipe(){this.ranges=[]}replace(e){if(Array.isArray(e)&&e.length)if(Array.isArray(e[0])&&E(e[0][0]))this.ranges=Array.from(e);else throw new Error(`ranges-push/Ranges/replace(): [THROW_ID_11] Single range was given but we expected array of arrays! The first element, ${JSON.stringify(e[0],null,4)} should be an array and its first element should be an integer, a string index.`);else this.ranges=[]}last(){return Array.isArray(this.ranges)&&this.ranges.length?this.ranges[this.ranges.length-1]:null}};var X={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function Y(e,n){function o(t){return!!t&&typeof t=="object"&&!Array.isArray(t)}if(!Array.isArray(e)||!e.length)return null;let i;if(n)if(o(n)){if(i=$($({},X),n),i.progressFn&&o(i.progressFn)&&!Object.keys(i.progressFn).length)i.progressFn=null;else if(i.progressFn&&typeof i.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof i.progressFn}", equal to ${JSON.stringify(i.progressFn,null,4)}`);if(![1,2,"1","2"].includes(i.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof i.mergeType}", equal to ${JSON.stringify(i.mergeType,null,4)}`);if(typeof i.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof i.joinRangesThatTouchEdges}", equal to ${JSON.stringify(i.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(n,null,4)} (type ${typeof n})`);else i=$({},X);let l=e.filter(t=>Array.isArray(t)).map(t=>[...t]).filter(t=>t[2]!==void 0||t[0]!==t[1]),r,a,s;i.progressFn?r=C(l,{progressFn:t=>{s=Math.floor(t/5),s!==a&&(a=s,i.progressFn(s))}}):r=C(l);let u=r.length-1;for(let t=u;t>0;t--)i.progressFn&&(s=Math.floor((1-t/u)*78)+21,s!==a&&s>a&&(a=s,i.progressFn(s))),(r[t][0]<=r[t-1][0]||!i.joinRangesThatTouchEdges&&r[t][0]<r[t-1][1]||i.joinRangesThatTouchEdges&&r[t][0]<=r[t-1][1])&&(r[t-1][0]=Math.min(r[t][0],r[t-1][0]),r[t-1][1]=Math.max(r[t][1],r[t-1][1]),r[t][2]!==void 0&&(r[t-1][0]>=r[t][0]||r[t-1][1]<=r[t][1])&&r[t-1][2]!==null&&(r[t][2]===null&&r[t-1][2]!==null?r[t-1][2]=null:r[t-1][2]!=null?+i.mergeType==2&&r[t-1][0]===r[t][0]?r[t-1][2]=r[t][2]:r[t-1][2]+=r[t][2]:r[t-1][2]=r[t][2]),r.splice(t,1),t=r.length);return r.length?r:null}var Te=!0,W="Invariant failed";function ee(e,n){if(!e){if(Te)throw new Error(W);var o=typeof n=="function"?n():n,i=o?"".concat(W,": ").concat(o):W;throw new Error(i)}}function re(e,n,o){let i=0,l=0;if(arguments.length===0)throw new Error("ranges-apply: [THROW_ID_01] inputs missing!");if(typeof e!="string")throw new TypeError(`ranges-apply: [THROW_ID_02] first input argument must be a string! Currently it's: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(n&&!Array.isArray(n))throw new TypeError(`ranges-apply: [THROW_ID_03] second input argument must be an array (or null)! Currently it's: ${typeof n}, equal to: ${JSON.stringify(n,null,4)}`);if(o&&typeof o!="function")throw new TypeError(`ranges-apply: [THROW_ID_04] the third input argument must be a function (or falsey)! Currently it's: ${typeof o}, equal to: ${JSON.stringify(o,null,4)}`);if(!(n!=null&&n.filter(f=>f).length))return e;let r;Array.isArray(n)&&Number.isInteger(n[0])&&Number.isInteger(n[1])?r=[Array.from(n)]:r=Array.from(n);let a=r.length,s=0;r.filter(f=>f).forEach((f,m)=>{if(o&&(i=Math.floor(s/a*10),i!==l&&(l=i,o(i))),!Array.isArray(f))throw new TypeError(`ranges-apply: [THROW_ID_05] ranges array, second input arg., has ${m}th element not an array: ${JSON.stringify(f,null,4)}, which is ${typeof f}`);if(!Number.isInteger(f[0])){if(!Number.isInteger(+f[0])||+f[0]<0)throw new TypeError(`ranges-apply: [THROW_ID_06] ranges array, second input arg. has ${m}th element, array ${JSON.stringify(f,null,0)}. Its first element is not an integer, string index, but ${typeof f[0]}, equal to: ${JSON.stringify(f[0],null,4)}.`);r[m][0]=+r[m][0]}if(!Number.isInteger(f[1])){if(!Number.isInteger(+f[1])||+f[1]<0)throw new TypeError(`ranges-apply: [THROW_ID_07] ranges array, second input arg. has ${m}th element, array ${JSON.stringify(f,null,0)}. Its second element is not an integer, string index, but ${typeof f[1]}, equal to: ${JSON.stringify(f[1],null,4)}.`);r[m][1]=+r[m][1]}s+=1});let u=Y(r,{progressFn:f=>{o&&(i=10+Math.floor(f/10),i!==l&&(l=i,o(i)))}});ee(u);let t=u.length;if(t>0){let f=e.slice(u[t-1][1]);e=u.reduce((m,y,c,h)=>{o&&(i=20+Math.floor(c/t*80),i!==l&&(l=i,o(i)));let g=c===0?0:h[c-1][1],T=h[c][0];return`${m}${e.slice(g,T)}${h[c][2]||""}`},""),e+=f}return e}var we={classicTrim:!1,cr:!1,lf:!1,tab:!1,space:!0,nbsp:!1};function x(e,n){if(typeof e!="string")throw new Error(`string-trim-spaces-only: [THROW_ID_01] input must be string! It was given as ${typeof e}, equal to:
${JSON.stringify(e,null,4)}`);let o=$($({},we),n);function i(a){return o.classicTrim&&!a.trim()||!o.classicTrim&&(o.space&&a===" "||o.cr&&a==="\r"||o.lf&&a===`
`||o.tab&&a==="	"||o.nbsp&&a==="\xA0")}let l,r;if(e.length){if(i(e[0]))for(let a=0,s=e.length;a<s;a++){if(!i(e[a])){l=a;break}if(a===e.length-1)return{res:"",ranges:[[0,e.length]]}}if(i(e[e.length-1])){for(let a=e.length;a--;)if(!i(e[a])){r=a+1;break}}return l?r?{res:e.slice(l,r),ranges:[[0,l],[r,e.length]]}:{res:e.slice(l),ranges:[[0,l]]}:r?{res:e.slice(0,r),ranges:[[r,e.length]]}:{res:e,ranges:[]}}return{res:"",ranges:[]}}var te="7.0.19";var Ae=te,ne={heads:["{{"],tails:["}}"]};function De(e,n){let o=Object.prototype.hasOwnProperty;if(e===void 0)throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_01] The input is missing!");if(typeof e!="string")return e;if(n&&!R(n))throw new Error(`string-remove-duplicate-heads-tails: [THROW_ID_03] The given options are not a plain object but ${typeof n}!`);let i=$({},n);if(i&&o.call(i,"heads"))if(S(i.heads).every(g=>typeof g=="string"||Array.isArray(g)))typeof i.heads=="string"&&(i.heads=S(i.heads));else throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_04] The resolvedOpts.heads contains elements which are not string-type!");if(i&&o.call(i,"tails"))if(S(i.tails).every(g=>typeof g=="string"||Array.isArray(g)))typeof i.tails=="string"&&(i.tails=S(i.tails));else throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_05] The resolvedOpts.tails contains elements which are not string-type!");let l=x(e).res;if(l.length===0)return e;e=l;let r=$($({},ne),i);r.heads=r.heads.map(g=>g.trim()),r.tails=r.tails.map(g=>g.trim());let a=!1,s=!1,u=new H({limitToBeAddedWhitespace:!0}),t=new H({limitToBeAddedWhitespace:!0}),f=!0,m=!0,y="";function c(g,T){let p;return N(g,0,T.heads,{trimBeforeMatching:!0,cb:(d,A,b)=>(p=b,!0)})&&N(g,p,T.tails,{trimBeforeMatching:!0,cb:(d,A,b)=>(p=b,!0)})?g.slice(p):g}for(;e!==c(e,r);)e=x(c(e,r)).res;function h(g,T){let p;return!V(g,g.length-1,T.tails,{trimBeforeMatching:!0,cb:(d,A,b)=>(p=b,!0)})||!p?g:V(g,p,T.heads,{trimBeforeMatching:!0,cb:(d,A,b)=>(p=b,!0)})?g.slice(0,p+1):g}for(;e!==h(e,r);)e=x(h(e,r)).res;if(!r.heads.length||!N(e,0,r.heads,{trimBeforeMatching:!0})||!r.tails.length||!V(e,e.length-1,r.tails,{trimBeforeMatching:!0}))return x(e).res;for(let g=0,T=e.length;g<T;g++)if(e[g].trim()!==""){let p;if(N(e,g,r.heads,{trimBeforeMatching:!0,cb:(d,A,b)=>(p=b,!0)})&&p){m=!0,f&&(f=!0);let d;N(e,p,r.tails,{trimBeforeMatching:!0,cb:(b,v,_)=>(d=_,!0)})&&u.push(g,d),t.current()&&a&&y!=="tails"&&u.push(t.current()),a||t.current()&&(u.push(t.current()),t.wipe()),t.push(g,p),y="heads",g=p-1;continue}if(N(e,g,r.tails,{trimBeforeMatching:!0,cb:(d,A,b)=>(p=Number.isInteger(b)?b:e.length,!0)})&&p){m=!0,f?(y==="heads"&&t.wipe(),f=!1):t.push(g,p),y="tails",g=p-1;continue}f&&(f=!0),m&&!a?(a=!0,m=!1):m&&!s?(s=!0,f=!0,m=!1,y==="heads"&&t.wipe()):m&&s&&t.wipe()}return t.current()&&u.push(t.current()),u.current()?re(e,u.current()).trim():e.trim()}return ce(Ee);})();
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.6.4
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name arrayiffy-if-string
 * @fileoverview Put non-empty strings into arrays, turn empty-ones into empty arrays. Bypass everything else.
 * @version 5.0.8
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/arrayiffy-if-string/}
 */
/**
 * @name string-match-left-right
 * @fileoverview Match substrings on the left or right of a given index, ignoring whitespace
 * @version 9.0.19
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-match-left-right/}
 */
/**
 * @name string-collapse-leading-whitespace
 * @fileoverview Collapse the leading and trailing whitespace of a string
 * @version 7.0.7
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-collapse-leading-whitespace/}
 */
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 6.0.11
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */
/**
 * @name ranges-push
 * @fileoverview Gather string index ranges
 * @version 7.0.15
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-push/}
 */
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 9.0.15
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */
/**
 * @name ranges-apply
 * @fileoverview Take an array of string index ranges, delete/replace the string according to them
 * @version 7.0.16
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-apply/}
 */
/**
 * @name string-trim-spaces-only
 * @fileoverview Like String.trim() but you can choose granularly what to trim
 * @version 5.0.10
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-trim-spaces-only/}
 */
